//***********************
// Partie implementation
// bibliotheque codeur
// Created by Cordier Yves december 2016
// V1.24 03/02/2018
// V1.3  28/07/2020
// fichier codeur.cpp
// **********************
// Les includes

#include "codeur.h"


// initialisation obligatoire pour que le compilateur retrouve ses petits ancre<n> sont des variables statiques 
// donc assimilables à des variables globales 

encoder* encoder::ancre0 = NULL;
#if maxCodeur > 1
encoder* encoder::ancre1 = NULL;
#endif
#if maxCodeur > 2
encoder* encoder::ancre2 = NULL;
#endif
#if maxCodeur > 3
encoder* encoder::ancre3 = NULL;
#endif
#if maxCodeur > 4
encoder* encoder::ancre4 = NULL;
#endif
#if maxCodeur > 5
encoder* encoder::ancre5 = NULL;
#endif
// **************
// Les méthodes
// **************
// Les interruptions statiques suivant le numero du codeur ainsi que le tableau "d'occupation"

boolean tablePrisCodeur[maxCodeur]={false
#if maxcodeur>1
	,false
#endif
#if maxcodeur>2
	,false
#endif
#if maxcodeur>3
	,false
#endif
#if maxcodeur>4
	,false
#endif
#if maxcodeur>5
	,false
#endif
};
#if maxCodeur > 5
void encoder::interruption5()// La procedure d'interruption
{
	ancre5->evolue();
}
#ifdef zerotrackexist
void encoder::interruptionzero5()// La procedure d'interruption pom
{
	ancre5->pom();
}
#endif
#endif
#if maxCodeur > 4
void encoder::interruption4()// La procedure d'interruption
{
	ancre4->evolue();
}
#ifdef zerotrackexist
void encoder::interruptionzero4()// La procedure d'interruption pom
{
	ancre4->pom();
}
#endif
#endif
#if maxCodeur > 3
void encoder::interruption3()// La procedure d'interruption
{
	ancre3->evolue();
}
#ifdef zerotrackexist
void encoder::interruptionzero3()// La procedure d'interruption pom
{
	ancre3->pom();
}
#endif
#endif
#if maxCodeur >2
void encoder::interruption2()// La procedure d'interruption
{
	ancre2->evolue();
}
#ifdef zerotrackexist
void encoder::interruptionzero2()// La procedure d'interruption pom
{
	ancre2->pom();
}
#endif
#endif
#if maxCodeur >1
void encoder::interruption1()// La procedure d'interruption
{
	ancre1->evolue();
}
#ifdef zerotrackexist
void encoder::interruptionzero1()// La procedure d'interruption pom
{
	ancre1->pom();
}
#endif
#endif
void encoder::interruption0()// La procedure d'interruption
{
	ancre0->evolue();
}
#ifdef zerotrackexist
void encoder::interruptionzero0()// La procedure d'interruption pom
{
	ancre0->pom();
}
#endif

// Change le sens de comptage
void encoder::setDirection(boolean mode)
{
	if (mode) {increment=1;} else {increment=-1;}
	
}


// retourne la valeur du compteur courant
long encoder::val() 
{
	return compt;
};

// retourne la valeur de la vitesse;
int  encoder::speed() 
{
	return vit;
};
// retourne la valeur de la vitesse;
int  encoder::avgSpeed() 
{
	return vitMoy;
};
// impose la valeur de alpha sur la moyenne exponentielle
void encoder::setAlpha(float alph)
{
	if (abs(alph)<=1)
	alpha=abs(alph);		
	else alpha=0.35;
	unMoinsAlpha=1.-alpha;
}

// incremente le compteur et calcul la vitesse;
void  encoder::evolue()
{
	
	static boolean inside = false; // paramètre pour éviter la réentrance
	if (inside)
	{
		return; // non réentrance
	}
	#ifdef _testOscillo
	PORTB=PORTB | 0x01; // pour les tests à l'oscillo sur avr
	#endif
	inside = true; // on y est !!
	unsigned long pulse = micros(); // enregistrement de l'instant actuel	
	boolean evol = true; // a priori évolution de compteur
	// on traite les différents types de compteur de codeur
	boolean A=false;
	
	switch (typeCodeur)
	{
	case unidirsimple : // sur front montant de A
		compt+=increment;
		break; // sortie du switch (typecodeur)
	case unidirdouble : // sur front montant et descendant de A
		compt+=increment;
		break; // sortie du switch (typecodeur)
	case bidirsimple : // sur front de A en discriminant le sens par /B
		#ifndef _ESrapide
		if (digitalRead(pinSens)) // B
		#else
		if(brochePinSens->read())
		#endif
		{
			sens=false;
			compt-=increment;
		}
		else
		{
			sens=true;
			compt+=increment;
		};
		break; // sortie du switch (typecodeur)

	case bidirdouble : // sur front montant et descendant de A en discriminant le sens
		#ifndef _ESrapide
		A = digitalRead(pinPulse); // etat de l'entrée pulse
		#else
		A = brochePinPulse->read();
		#endif
		#ifndef _ESrapide
		boolean B = digitalRead(pinSens);
		#else
		boolean B= brochePinSens->read();
		#endif
		if ((stoA && !A  && B) || (!stoA && A && !B))
		{
			compt+=increment;
			sens = true;
			break;
		}
		else
		{
			compt-=increment;
			sens = false;
			break;
		};
		break; // sortie du switch (typecodeur)
	default:
		{ 
			evol=false; // dans tous les autres cas (qui ne doivent normalement jamais arriver)
		}
		break;		
	}
	
	stoA = A; // dernier etat connu de l'entrée pulse sauvée
	// Calcul du paramete vitesse
	if ((vitCalcul || vitMoyCalcul) && evol)
	{
		unsigned long d; // temps en microseconde entre les deux derniers pulses enregistrés
		if (pulse > dernierPulse)
		{
			d = pulse - dernierPulse;
		}
		else
		{
			d = (4294967295ul - dernierPulse) + pulse;
		}
		if (d > 1000000)
		{
			vit = 0; // pas d'impulsion pendant 1 seconde
		}
		else
		{
			vit = (1000000. / d); // nb d'mpulsions par seconde
		}
		if (!sens) {
			vit = -vit; // gestion du sens de parcours
		}
		if (vitMoyCalcul)
		{// traitement de la vitesse moyenne sur maxtablevitesse valeurs
			// Traitement sur une moyenne fenetre classique
			/*
			if ((vit*vitMoy)<=0) 
			{
				pointeurvitesse=0;
				nbvitesse=1;
			}
			else 
			{
				if (nbvitesse<maxtablevitesse)
				{
					nbvitesse++;
					pointeurvitesse++;
				}
				else
				{
					pointeurvitesse=(pointeurvitesse++)%maxtablevitesse;
				}
			}
			tablevitesse[pointeurvitesse]=vit;
			long V=0;
			for (int i=0; i<nbvitesse; i++)
			{
				V+=tablevitesse[i];
			}
			vitMoy=int(float(V)/nbvitesse);
			
			*/
			
			
			// traitement en utilisant la moyenne glissante exponentielle vitMoy=(1-alpha)*vitMoy+alpha * vit
			// alpha=0.35 est un bon compromis
			if ((vit*vitMoy)<=0) 
			{
				vitMoy=vit;
			}
			else 
			{
				vitMoy=unMoinsAlpha*vitMoy+alpha*vit;
			}
			
			
		}
		dernierPulse = pulse;
	}
	inside = false;
	#ifdef _testOscillo
	PORTB=PORTB & 0xFE; // pour les tests à l'oscillo sur avr
	#endif
}

// reset
void  encoder::reset()
{
	compt = 0;
	vit = 0;
	vitMoy=0;
	// for (int i=0; i<maxtablevitesse; i++){tablevitesse[i]=0;}
	// pointeurvitesse=0;
	// nbvitesse=0;
	#ifndef _ESrapide
	stoA = digitalRead(pinPulse);
	#else
	stoA=brochePinPulse->read();
	#endif
	sens = true;
}

// met en marche le compteur en remettant en place les interruptions
void  encoder::run()
{
	dernierPulse = micros();
	marche=true;
	byte mode;
	if ((typeCodeur==unidirsimple)||(typeCodeur==bidirsimple)) 
	{mode=RISING;}
	else 
	{mode=CHANGE;}
	
#if maxCodeur == 1
	attachInterrupt(interpulse, encoder::interruption0, mode );
	
#endif

#if maxCodeur > 1
	switch (numCodeur)
	{
	case 0 : attachInterrupt(interpulse, encoder::interruption0, mode ); break;

	case 1 : attachInterrupt(interpulse, encoder::interruption1, mode );  break;

#if maxCodeur > 2
	case 2 : attachInterrupt(interpulse, encoder::interruption2, mode ); break;
#endif
#if  maxCodeur > 3
	case 3 : attachInterrupt(interpulse, encoder::interruption3, mode );  break;
#endif
#if maxCodeur > 4
	case 4 : attachInterrupt(interpulse, encoder::interruption4, mode );  break;
#endif
#if maxCodeur > 5
	case 5 : attachInterrupt(interpulse, encoder::interruption5, mode );  break;
#endif

	}
	
#endif
	marche = true; 
	
	
}

// arrete le compteur
void  encoder::stop()
{
	marche = false;
	detachInterrupt(interpulse);
#ifdef zerotrackexist
	if (pomArmed && pisteZeroOK)
	{
		pomReset();
	}	  
#endif
	vit = 0;
	vitMoy=0;
}

// force la valeur du compteur
void encoder::setVal(long v)
{
	noInterrupts();
	compt=v;
	interrupts();
}

#ifdef zerotrackexist
// preparation à la prise de pom
void encoder::pomSet()
{
	// mise en place de l'interruption pom()
	
	if (pisteZeroOK)
	{
		
#if maxCodeur == 1
		attachInterrupt(interzero, encoder::interruptionzero0, RISING );
		
#endif
#if maxCodeur > 1
		switch (numCodeur)
		{
		case 0 : attachInterrupt(interzero, encoder::interruptionzero0,RISING );  break;

		case 1 : attachInterrupt(interzero, encoder::interruptionzero1, RISING ); break;
#if  maxCodeur > 2
		case 2 : attachInterrupt(interzero, encoder::interruptionzero2, RISING );  break;
#endif
#if  maxCodeur > 3
		case 3 : attachInterrupt(interzero, encoder::interruptionzero3, RISING );  break;
#endif
#if maxCodeur > 4
		case 4 : attachInterrupt(interzero, encoder::interruptionzero4, RISING );  break;
#endif
#if maxCodeur > 5
		case 5 : attachInterrupt(interzero, encoder::interruptionzero5, RISING );  break;
#endif
		}
#endif
		pomArmed=true;

		
		
	}
}
// annulation de l prise de pom
void encoder::pomReset() 
{
	pomArmed=false;
	detachInterrupt(interzero);
}
// n'est jamais appelé par l'utilisateur mais correspond 
// à la procédure appelée par l'interruption Prise Origine Machine
void encoder::pom()
{
	if (pomArmed)
	{
		compt=0;
		pomArmed=false;
		detachInterrupt(interzero);
	}
}
// retourne l'état de pomArmed
boolean encoder::pomDone()
{
	return (!pomArmed);
}
#endif

byte encoder::errornum()
{
	return numerreur;
}
// Createur
#ifdef zerotrackexist
encoder::encoder(byte type, int num1, int num2, int num3)
#else
encoder::encoder(byte type, int num1, int num2)
#endif
{
	// On releve les caractéristiques du codeur demandé
	
	vitCalcul=((vitMoyCalcul= ((type & avgspeedcompute)>0))|((type & speedcompute)>0));;
	typeCodeur = type & (bidirect | doubleprecision); // on isole les bits du type de codeur 
	// le sens de comptage normal par defaut 
	increment=1; // peut se changer par la fonction setDirection(true|false);
	// verification des données
	numerreur=0;
	// Verification de la cohérence des pin interruptibles
	interpulse=digitalPinToInterrupt(num1);
	if (( num1<0)||(interpulse == NOT_AN_INTERRUPT))
	{numerreur=pinpulsenotaninterrupt+numerreur;}
	else
	{		
		#ifndef _ESrapide
		pinPulse=num1;
		pinMode(num1, INPUT_PULLUP);
		#else
		brochePinPulse=new FastInOut(num1,INPUT_PULLUP);	
		#endif
	}
	// la pin sens
	#ifndef _ESrapide
	pinSens  = num2; 
	#endif
	if ((typeCodeur & bidirect)>0)
	{
		if (num2>0)
		{
			#ifdef _ESrapide
			brochePinSens=new FastInOut(num2,INPUT_PULLUP);
			#else
			pinMode(num2,INPUT_PULLUP);
			#endif
		}
		else 
		{
			numerreur=numerreur+bidirectimpossible;
		}
	}	 
	
	// la pin zerotrack
	
	#ifdef zerotrackexist
	pisteZeroOK = ((type & pulsezerotrack)>0);
	
	if (pisteZeroOK)
	{
		interzero=digitalPinToInterrupt(num3);
		if ((num3<0) ||(interzero== NOT_AN_INTERRUPT))
		{
			numerreur=pinzeronotaninterrupt + numerreur;
			pisteZeroOK=false;
		}
		
		else 
		
		{
			#ifdef _ESrapide
			brochePinZero=new FastInOut(num3,INPUT_PULLUP);
			#else
			pinMode(num3, INPUT_PULLUP); // on prend en compte la piste top zero
			#endif
			
		}
	}
	
	#endif
	// mise en place de la valeur du coef alpha pour la moyenne exponentielle
	setAlpha();
	// détection d'un entrée libre de la table des pointeurs codeurs ou de la dernière.
	byte i=0;
	while(tablePrisCodeur[i] && (i<(maxCodeur-1))) {i++;};
	numCodeur = i ; 
	if (tablePrisCodeur[i])
	{ 
		numerreur=numerreur+notanencoderavailable;
	}
	tablePrisCodeur[i]=true;

	// pour stocker l'adresse de l'objet encoder créé affin de commuter la bonne procédure d'interruption
#if maxCodeur == 1
	ancre0=this;
#endif
#if maxCodeur > 1
	switch (numCodeur)
	{
	case 0 : ancre0 = this;  break;

	case 1 : ancre1 = this; break;

#if maxCodeur > 2
	case 2 : ancre2 = this; break;
#endif
#if maxCodeur > 3
	case 3 : ancre3 = this; break;
#endif
#if maxCodeur > 4
	case 4 : ancre4 = this; break;
#endif
#if maxCodeur > 5
	case 5 : ancre4 = this; break;
#endif
	}
	
#endif
	
	
	if (numerreur==0)
	{
		reset();
		run();
	}
}
// destructeur
encoder::~encoder()
{
	stop();
#ifdef _ESrapide
	// on libere la memoire des ES rapides
	delete brochePinPulse;
	if ((typeCodeur & bidirect)>0) delete brochePinSens;
	#ifdef zerotrackexist
	delete brochePinZero;
	#endif
#endif	
	tablePrisCodeur[numCodeur]=false; // on libère la table
}

// fin de la bibli
// ****************************

